local FishWarden = FishWarden_79a6ca19_6666_4759_9b8f_a67708694e5b;

FishWarden.GUI = {};
FishWarden.GUI.MainFrame = CreateFrame("Frame", "FishWardenPanel", UIParent);

local MainFrame = FishWarden.GUI.MainFrame;

function MainFrame:DoInit()
    local checkwidth = 26;

    MainFrame.name = "Fish Warden";
    MainFrame:SetScript("OnEvent", MainFrame.EventHandler);
    MainFrame:SetScript("OnShow", MainFrame.ShowHandler);
    
    MainFrame.iddTitle = MainFrame:CreateFontString("$parent_Title","ARTWORK","GameFontNormalLarge");
    MainFrame.iddTitle:SetPoint("TOPLEFT", MainFrame, "TOPLEFT", 13, -13);
    MainFrame.iddTitle:SetText("Fish Warden v" .. FishWarden.FWVERSION);
    MainFrame.iddTitle:SetJustifyH("CENTER");
    
    MainFrame.iddHelp = MainFrame:CreateFontString("$parent_Help","ARTWORK","GameFontNormal");
    MainFrame.iddHelp:SetPoint("TOPLEFT", MainFrame.iddTitle, "BOTTOMLEFT", 0, -8);
    MainFrame.iddHelp:SetText("|cffffffff    " .. FishWarden.Locale.Help .. "|r");
    MainFrame.iddHelp:SetJustifyH("LEFT");
    MainFrame.iddHelp:SetJustifyV("TOP");

    MainFrame.iddEnableBtn = CreateFrame("CheckButton", "$parent_EnableBtn", MainFrame, "UICheckButtonTemplate");
    MainFrame.iddEnableBtn:SetWidth(checkwidth);
    MainFrame.iddEnableBtn:SetHeight(checkwidth);
    MainFrame.iddEnableBtn:SetPoint("TOPLEFT", MainFrame.iddHelp, "BOTTOMLEFT", 0, -8);
    MainFrame.iddEnableBtn:SetScript("OnClick", MainFrame.OnClickEnable);

    MainFrame.iddEnableBtnText = getglobal(MainFrame.iddEnableBtn:GetName() .. 'Text');
    MainFrame.iddEnableBtnText:SetText(ENABLE);
    MainFrame.iddEnableBtnText:SetJustifyH("LEFT");

    MainFrame.iddEnableBtnClicker = CreateFrame("Button", "$parent_EnableBtnClicker", MainFrame);
    MainFrame.iddEnableBtnClicker:SetAllPoints(MainFrame.iddEnableBtnText);
    MainFrame.iddEnableBtnClicker:SetScript("OnClick", MainFrame.OnClickEnable);
    MainFrame.iddEnableBtnClicker:SetScript("OnEnter", function () MainFrame.iddEnableBtn:LockHighlight(); end);
    MainFrame.iddEnableBtnClicker:SetScript("OnLeave", function () MainFrame.iddEnableBtn:UnlockHighlight(); end);
end

function MainFrame:refresh()
    MainFrame.iddEnableBtn:SetChecked(FishWarden.Vars.Enable);
end

function MainFrame:Toggle()
    if InterfaceOptionsFrame:IsVisible() then
        InterfaceOptionsFrame:Hide();
    else
        InterfaceOptionsFrame_OpenToCategory(MainFrame);
    end
end

function MainFrame:EventHandler(event, ...)
    if (FishWarden[event]) then
        FishWarden[event](self, ...);
    end
end

function MainFrame:ShowHandler(...)
    local maxwidth = MainFrame:GetWidth();
    if (maxwidth == 0) then maxwidth = 413; end

    MainFrame.iddTitle:SetWidth(maxwidth - 26);
    MainFrame.iddHelp:SetWidth(maxwidth - 26);

    MainFrame.iddEnableBtnText:SetWidth(min(MainFrame.iddEnableBtnText:GetStringWidth(),
                                            maxwidth - MainFrame.iddEnableBtn:GetWidth() - 26));
end

function MainFrame:OnClickEnable(button)
    if (button == "LeftButton") then
        FishWarden:SetEnable();
        MainFrame.iddEnableBtn:SetChecked(FishWarden.Vars.Enable);
    end
end

